require("net")
require("tbform")
require("uci_iwaddon")
require("strform")

cportal = {}
local P = {}
cportal = P
-- Import Section:
-- declare everything this package needs from outside
local tonumber = tonumber
local pairs = pairs
local ipairs = ipairs
local pairsByKeys = pairsByKeys
local print = print
local net = net
local os = os
local io = io
local string = string
local tostring = tostring
local uci = uci
local next = next
local type = type
local ordertable = ordertable
local load_file = load_file
local strform = strform

local menuClass = menuClass
--local __UCI_VERSION = __UCI_VERSION
local formClass = formClass
local __SERVER = __SERVER
local __FORM = __FORM
local __MENU = __MENU
local tr = tr
local tbformClass = tbformClass
-- no more external access after this point
setfenv(1, P)
if __FORM.pageremove and __FORM.pageremove ~= "" then
	os.execute("rm "..uci.get("chillipages",__FORM.pageremove,"filename"))
	uci.delete("chillipages",__FORM.pageremove)
end

if __FORM["allowed_site"] and __FORM["allowed_site"] ~= "" then
  local sitesallowed = uci.add("coovachilli","sitesallowed")
  uci.set("coovachilli",sitesallowed,"site",__FORM["allowed_site"])
end

if __FORM["DeleteAllowed"] then
	uci.delete("coovachilli",__FORM["DeleteAllowed"])
end



if __FORM["pagemenu"] and string.trim(__FORM["pagemenu"])~= "" then
	local pages = uci.add("chillipages","pages")
	uci.set("chillipages",pages,"pagemenu", __FORM["pagemenu"])
	uci.set("chillipages",pages,"pagetitle",__FORM["pagetitle"])
	uci.set("chillipages",pages,"pagetype", __FORM["pagetype"])
	uci.set("chillipages",pages,"menuorder", __FORM["menuorder"])
	local deffile = ""
	local findfile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/"..pages
	if  __FORM.pagetype == "html" then
		deffile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/html_example"
		uci.set("chillipages",pages,"filename", filefind)
	elseif  __FORM.pagetype == "fields" then
		deffile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/field_example"
		findfile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/"..pages
		uci.set("chillipages",pages,"filename", findfile)
	else
		deffile = "/www/file_example.html"
		findfile = "/www/"..pages
		uci.set("chillipages",pages,"filename", "/"..pages)
	end	
  os.execute("cp "..deffile.." "..findfile)
end
uci.save("chillipages")

uci.check_set("coovachilli","webadmin","coovachilli")
uci.check_set("coovachilli","system","coovachilli")

uci.check_set("coovachilli","webadmin","enable","1")
uci.check_set("coovachilli","system","apply","/usr/lib/lua/lua-xwrt/applys/coovachilli.lua")

uci.check_set("coovachilli","settings","coovachilli")
uci.check_set("coovachilli","homepage","coovachilli")
uci.check_set("coovachilli","checked","coovachilli")

--uci.check_set("coovachilli","settings","HS_WWWDIR","/etc/chilli/www")
--uci.check_set("coovachilli","settings","HS_WWWBIN","/etc/chilli/wwwsh")
uci.check_set("coovachilli","homepage","redirect","0")

local userlevel = tonumber(uci.check_set("coovachilli","webadmin","userlevel","1"))
local radconf   = tonumber(uci.check_set("coovachilli","webadmin","radconf","0"))
-- portal = 1 la pagina de login en el AP
-- portal = 2 la página de login en un servidor Externo
local portal    = tonumber(uci.check_set("coovachilli","webadmin","portal","1"))
uci.check_set("coovachilli","settings","HS_MODE","hotspot")
uci.check_set("coovachilli","settings","HS_ANYDNS","on")
uci.check_set("coovachilli","settings","HS_DNS1","192.168.182.1")
uci.check_set("coovachilli","settings","HS_DNS2","204.225.44.3")
uci.check_set("coovachilli","settings","HS_NETMASK","255.255.255.0")
--uci.check_set("coovachilli","settings","HS_NETWORK","192.168.182.0")
uci.check_set("coovachilli","settings","HS_LANIF","br-wifi")

--uci.check_set("coovachilli","settings","HS_UAMSERVER","192.168.182.1")
uci.check_set("coovachilli","settings","HS_UAMLISTEN","192.168.182.1")
uci.check_set("coovachilli","settings","HS_UAMPORT","3990")
--uci.check_set("coovachilli","settings","HS_UAMHOMEPAGE","http://$HS_UAMLISTEN:$HS_UAMPORT/www/coova.html")
--uci.check_set("coovachilli","settings","HS_UAMFORMAT","http://$HS_UAMSERVER/cgi-bin/login/login")

uci.check_set("coovachilli","settings","HS_NASID","X-Wrtnas")
uci.check_set("coovachilli","settings","HS_LOC_NAME","My X-Wrt Hotspot")
uci.check_set("coovachilli","settings","HS_LOC_NETWORK","X-Wrt Network")

--uci.check_set("coovachilli","settings","HS_UAMALLOW","x-wrt.org,coova.org,www.internet-wifi.com.ar")

uci.check_set("coovachilli","settings","HS_RADAUTH","1812")
uci.check_set("coovachilli","settings","HS_RADACCT","1813")

if radconf > 0 then
  uci.check_set("coovachilli","settings","HS_RADIUS2","127.0.0.1")
  uci.check_set("coovachilli","settings","HS_RADIUS","127.0.0.1")
  uci.check_set("coovachilli","settings","HS_RADSECRET","testing123")
end

if uci.check_set("coovachilli","webadmin","loginpage","1") == "1" then
	uci.set("coovachilli","settings","HS_UAMFORMAT", "http://"..uci.get("coovachilli","settings","HS_UAMLISTEN").."/cgi-bin/login/login")
end

local pages = uci.get_type("chillipages","pages") 
if pages == nil then
	local newpage = uci.add("chillipages","pages")
	uci.set("chillipages",newpage,"menuorder","1") 
	uci.set("chillipages",newpage,"pagemenu","About") 
	uci.set("chillipages",newpage,"pagetitle","X-Wrt Infopage") 
	uci.set("chillipages",newpage,"pagetype","html")
	uci.set("chillipages",newpage,"filename","/usr/lib/lua/lua-xwrt/pkgs/coovachilli/"..newpage)
	os.execute("cp /usr/lib/lua/lua-xwrt/pkgs/coovachilli/html_example /usr/lib/lua/lua-xwrt/pkgs/coovachilli/"..newpage)
	uci.save("chillipages")
end

if uci.check_set("coovachilli","webadmin","homepage","0") == "0" then
	uci.delete("coovachilli","settings","HS_UAMHOMEPAGE")
elseif uci.get("coovachilli","webadmin","homepage") == "1" then
	uci.set("coovachilli","settings","HS_UAMHOMEPAGE","http://"..uci.get("coovachilli","settings","HS_UAMLISTEN").."/cgi-bin/login/home")
end


uci.save("coovachilli")

function reorderpages()
	local tin = ordertable(uci.get_type("chillipages","pages"),"menuorder")
	if tin then
		idx = 1
		for i,t in pairsByKeys(tin) do
			if tonumber(i) ~= idx then
				uci.set("chillipages",t[".name"],"menuorder",idx)
			end
			idx = idx + 1
		end
		uci.save("chillipages")
		return ordertable(uci.get_type("chillipages","pages"),"menuorder")
	end
	return nil
end	

function set_menu()
  __MENU.HotSpot["Coova-Chilli"] = menuClass.new()
  __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Core#Core","coovachilli.sh")
  if userlevel > 1 then
    __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_DHCP#Network","coovachilli.sh?option=net")
  	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Portal#Portal","coovachilli.sh?option=uam")

  	if radconf < 2 then
    	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Radius#Radius","coovachilli.sh?option=radius")
  	end
  	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_NasId#NAS ID","coovachilli.sh?option=nasid")
  	if radconf > 1 then
    	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Users#Users","coovachilli.sh?option=users")
  	end
  	if radconf > 1 then
    	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Communities#Communities","coovachilli.sh?option=communities")
  	end
--    __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Access#Access","coovachilli.sh?option=access")
--    __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Proxy#Proxy","coovachilli.sh?option=proxy")
--    __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Scripts#Extras","coovachilli.sh?option=extras")
  end
  
	__MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_pages#HotSpotPages")
	__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"] = menuClass.new()
	local loginset = tonumber(uci.get("coovachilli", "webadmin", "loginpage"))
	if loginset == 1 then
		__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]:Add("Login","coovachilli.sh?option=login") 
	end
	__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]:Add("Define","coovachilli.sh?option=pages") 
	local npages = reorderpages()
	if npages then
--		__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]:Add("Edit")
--		__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]:Add("View")
--		__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]["Edit"] = menuClass.new()
--		__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]["View"] = menuClass.new()
		for i, t in ipairs(npages) do
--			__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]["Edit"]:Add(t.pagemenu,"coovachilli.sh?option=editpage&page="..t[".name"])
--			__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]["View"]:Add(t.pagemenu,"coovachilli.sh?option=showpage&page="..t[".name"])
			__MENU.HotSpot["Coova-Chilli"]["chilli_menu_pages#HotSpotPages"]:Add(t.pagemenu,"coovachilli.sh?option=edit&page="..t[".name"])
		end
	end

--  if tonumber(hotspot.service.enable) == 1 then
    __MENU.HotSpot["Coova-Chilli"]:Add("chilli_menu_Connections#Connections","coovachilli.sh?option=connections")
--  end
end

function get_wifinet(user_level)
	local user_level = user_level or userlevel
  local t = {}
  local n = 0
  local filternet = {}
  filternet["wan"] = ""
  filternet["loopback"] = ""
  if user_level < 2 then
  	filternet["lan"] = ""
  end
--[[
	uci.check_set("network","wifi","interface")
	uci.check_set("network","wifi","proto","static")
	uci.check_set("network","wifi","type","bridge")
]]--
--	uci.check_set("network","wifi","ifname",iwifi[i].device)
--	uci.check_set("network","wifi","ipaddr","192.168.2.2")
--	uci.check_set("network","wifi","netmask","255.255.255.0")
	uci.save("network")
  
  local nets = net.networks()
  local iwifi = uci.get_type("wireless","wifi-iface")
  if iwifi then
		for i, u in pairs(nets) do
			if filternet[i] == nil then
				for j=1, #iwifi do
					local name = i.." on "..iwifi[j].device
					t[name]=i..":"..iwifi[j].device
					n = n + 1
				end
			end
		end
		local unico = next(t)
		return t, n, t[unico]
	end
	return nil, nil, nil
end

function core_form(form,user_level,rad_conf)
  local user_level = user_level or userlevel;
  local rad_conf = rad_conf or radconf
  local form = form
  
  if form == nil then
    form = formClass.new(tr("chilli_title_service#Service"))
  else
    form:Add("subtitle",tr("chilli_title_service#Service"))
  end

	form:Add("select","coovachilli.webadmin.enable",uci.check_set("coovachilli","webadmin","enable","1"),tr("chilli_var_service#Service"),"string")
	form["coovachilli.webadmin.enable"].options:Add("0","Disable")
	form["coovachilli.webadmin.enable"].options:Add("1","Enable")
  form:Add_help(tr("chillispot_var_enable#Service"),tr("chilli_help_enable#Enable or disable service."))

	form:Add("select","coovachilli.webadmin.loginpage",uci.check_set("coovachilli","webadmin","loginpage","1"),tr("chilli_var_loginpage#Login Page"),"string")
	form["coovachilli.webadmin.loginpage"].options:Add("0","External")
	form["coovachilli.webadmin.loginpage"].options:Add("1","Internal")
  form:Add_help(tr("chillispot_var_loginpage#Login Page"),tr("chilli_help_loginpage#Set internal or external login page."))

	form:Add("select","coovachilli.webadmin.homepage",uci.check_set("coovachilli","webadmin","homepage","0"),tr("chilli_var_homepage#Home Page"),"string")
	form["coovachilli.webadmin.homepage"].options:Add("0","Disable")
	form["coovachilli.webadmin.homepage"].options:Add("1","Internal")
	form["coovachilli.webadmin.homepage"].options:Add("2","External")
  form:Add_help(tr("chillispot_var_homepage#Internal Home Page"),tr("chilli_help_homepage#Set disable, internal home page or external home page."))

  if string.match(__SERVER["SCRIPT_FILENAME"],"coovachilli.sh") then
  	form:Add("select","coovachilli.webadmin.userlevel",uci.check_set("coovachilli","webadmin","userlevel","0"),tr("userlevel#User Level"),"string")
    form["coovachilli.webadmin.userlevel"].options:Add("0","Select Mode")
    form["coovachilli.webadmin.userlevel"].options:Add("1","Beginer")
--    form["coovachilli.webadmin.userlevel"].options:Add("2","Medium")
    form["coovachilli.webadmin.userlevel"].options:Add("3","Advanced")
--    form["coovachilli.webadmin.userlevel"].options:Add("4","Expert")
		form:Add_help(tr("chillispot_var_UserLevel#User Level"),tr([[
			chilli_help_UserLevel#<strong>Beginer:</strong> Do all necesary setting for you, including Wireless and Networ settings<br>
			<strong>Advanced:</strong> In this mode you can set more options, but not check that you do and not set or check Wireless and/or Networks.<br>
			<strong>Note:</strong> Could be good idea if at first time you use beginer mode.
			]]))

	  form:Add("select","coovachilli.webadmin.radconf",uci.check_set("coovachilli","webadmin","radconf","0"),tr("authentication_users#Authenticate Users Mode"),"string")
  	form["coovachilli.webadmin.radconf"].options:Add("0","Communities Users with Remote Radius")
  	form["coovachilli.webadmin.radconf"].options:Add("1","Local Users with Local Radius")
  	form["coovachilli.webadmin.radconf"].options:Add("2","Comunities Users with Local Radius")
  	form["coovachilli.webadmin.radconf"].options:Add("3","Communities & Local Users with Local Radius")
  	form:Add_help(tr("chillispot_var_authentication_users#Authenticate Users Mode"),tr("chillispot_help_authentication_users#Select authentication Mode."))
  else
    uci.set("coovachilli","webadmin","userlevel",user_level)
    uci.set("coovachilli","webadmin","radconf",rad_conf)
  end
--[[
  if user_level > 1 then
  	form:Add("select","coovachilli.webadmin.portal",uci.check_set("coovachilli","webadmin","portal","2"),tr("portal#Portal Settings"),"string")
--  	form["coovachilli.webadmin.portal"].options:Add("0","Coova Server")
    form["coovachilli.webadmin.portal"].options:Add("1","Internal Server")
    form["coovachilli.webadmin.portal"].options:Add("2","Remote Server")
  end
]]--
  uci.save("coovachilli")
  if user_level < 2 then
		form = nasid_form(form, user_level)
		form = net_form(form,user_level,portal)
		form = uam_form(form,user_level,portal)
		form = radius_form(form,user_level, rad_conf)
	end    
  return form
end

function net_form(form,user_level,localuam)
  local user_level = user_level or userlevel
  local form = form
  local ifiw, n, unico = get_wifinet(user_level)
	
	if n ~= nil then
	if user_level > 1 or n > 1 then
  	if form == nil then
    	form = formClass.new(tr("Network Settings"))
  	else
    	form:Add("subtitle",tr("Network Settings"))
  	end

  	if user_level < 2 then
    	if tonumber(n) > 1 then
      	form:Add("select","coovachilli.webadmin.HS_LANIF",uci.get("coovachilli","settings","HS_LANIF"),tr("cportal_var_ifwifi#Wireless Interface"),"string")
      	for k, v in pairs(ifiw) do
        	form["coovachilli.webadmin.HS_LANIF"].options:Add(v,k)
      	end
    	end    
  	end
  else
		if unico then
			uci.set("coovachilli","webadmin","HS_LANIF",unico)
			uci.save("coovachilli")
		end
	end
	end
  if user_level > 1 or unico == nil then

	  local dev
    dev = net.invert_dev_list() -- for advanced users
	  form:Add("select","coovachilli.settings.HS_LANIF",uci.check_set("coovachilli","settings","HS_LANIF","br-wifi"),tr("cportal_var_device#Device Network"),"string")
  	for k, v in pairs(dev) do
    	if v ~= "loopback"
    	and v ~= "wan" then
				form["coovachilli.settings.HS_LANIF"].options:Add(k,v)
			end
  	end

	  form:Add("text", "coovachilli.settings.HS_UAMLISTEN", uci.check_set("coovachilli","settings","HS_UAMLISTEN","192.168.182.1"),tr("cportal_var_uamlisten#HotSpot Internal IP Address"),"string")
--  This param can be calculated 
--  form:Add("text", "coovachilli.settings.HS_NETWORK", uci.check_set("coovachilli","settings","HS_NETWORK","192.168.182.0"),tr("cportal_var_net#HotSpot DHCP Network"),"string")
  	form:Add("text", "coovachilli.settings.HS_NETMASK", uci.check_set("coovachilli","settings","HS_NETMASK","255.255.255.0"),tr("cportal_var_net#HotSpot DHCP Netmask"),"string")
  	form:Add("subtitle","Optional Advanced Settings")
  	form:Add("text", "coovachilli.settings.HS_DYNIP", uci.get("coovachilli","settings","HS_DYNIP"),tr("cportal_var_dynip#Dynamic IP"),"string")
  	form:Add("text", "coovachilli.settings.HS_DYNIP_MASK", uci.get("coovachilli","settings","HS_DYNIP_MASK"),tr("cportal_var_staticip#Dynamic IP Mask"),"string")
  	form:Add("text", "coovachilli.settings.HS_STATIP", uci.get("coovachilli","settings","HS_STATIP"),tr("cportal_var_staticip#Static IP"),"string")
  	form:Add("text", "coovachilli.settings.HS_STATIP_MASK", uci.get("coovachilli","settings","HS_STATIP_MASK"),tr("cportal_var_staticip#Static IP Mask"),"string")

--  This do not work or I don't understand How it work  
--  	form:Add("select","coovachilli.check.HS_ANYIP", uci.check_set("coovachilli","check","HS_ANYIP","1"),tr("cportal_var_anyip#Allow Any IP"),"int")
--  	form["coovachilli.check.HS_ANYIP"].options:Add("no",tr("disable#Disable"))
--  	form["coovachilli.check.HS_ANYIP"].options:Add("",tr("enable#Enable"))

  	form:Add("subtitle","Extras")  
  	form:Add("text", "coovachilli.settings.HS_DNS_DOMAIN", uci.get("coovachilli","settings","HS_DNS_DOMAIN"),tr("cportal_var_net#Domain"),"string")
  	form:Add("text", "coovachilli.settings.HS_DNS1", uci.check_set("coovachilli","settings","HS_DNS1","192.168.182.1"),tr("cportal_var_dns#DNS Server").." 1","string")
  	form:Add("text", "coovachilli.settings.HS_DNS2", uci.check_set("coovachilli","settings","HS_DNS2","204.225.44.3"),tr("cportal_var_dns#DNS Server").." 2","string")

--  form:Add("text", "coovachilli.settings.HS_UAMSERVER", uci.check_set("coovachilli","settings","HS_UAMSERVER","192.168.182.1"),tr("cportal_var_uamserver#Server"),"string")
--  form:Add("text", "coovachilli.settings.HS_UAMPORT", uci.check_set("coovachilli","settings","HS_UAMPORT","3990"),tr("cportal_var_net#Port"),"string")
	end
	uci.save("coovachilli")
  return form
end

function radius_form(form,user_level,rad_conf)
  local user_level = user_level or userlevel
  local form = form
  local rad_conf = rad_conf or radconf

  if form == nil then
    form = formClass.new(tr("Coovachilli - Radius Settings"))
  else
    form:Add("subtitle",tr("Radius Settings"))
  end
----	Input Section form
	if rad_conf == 0 then
	  form:Add("text","coovachilli.settings.HS_RADIUS",uci.check_set("coovachilli","settings","HS_RADIUS","rad01.internet-wifi.com.ar"),tr("chilli_var_radiusserver1#Primary Radius"),"string,required","width:90%")
  	form:Add("text","coovachilli.settings.HS_RADIUS2",uci.check_set("coovachilli","settings","HS_RADIUS2","rad02.internet-wifi.com.ar"),tr("chilli_var_radiusserver2#Secondary Radius"),"string,required","width:90%")
  	form:Add_help(tr("chilli_help_title_radiusserver#Primary / Secondary Radius"),tr("chilli_help_radiusserver#Primary and Secondary Radius Server|Ip or url address of Radius Servers. If you have only one radius server you should set Secondary radius server to the same value as Primary radius server."))
  	form:Add("text","coovachilli.settings.HS_RADAUTH",uci.check_set("coovachilli","settings","HS_RADAUTH","1812"),tr("chilli_var_radiusauthport#Authentication Port"),"int,>0")
  	form:Add("text","coovachilli.settings.HS_RADACCT",uci.check_set("coovachilli","settings","HS_RADACCT","1813"),tr("chilli_var_radiusacctport#Accounting Port"),"int,>0")
  	form:Add_help(tr("chilli_help_title_radiusports#Authentication / Accounting Ports"),tr("chilli_help_radiusports#Radius authentication and accounting port|The UDP port number to use for radius authentication and accounting requests. The same port number is used for both radiusserver1 and radiusserver2."))
	else
    uci.set("coovachilli","settings","HS_RADIUS","127.0.0.1") 
    uci.set("coovachilli","settings","HS_RADIUS2","127.0.0.1") 
    uci.set("coovachilli","settings","HS_RADAUTH","1812") 
    uci.set("coovachilli","settings","HS_RADACCT","1813") 
    uci.save("coovachilli") 
	end
  form:Add("text","coovachilli.settings.HS_RADSECRET",uci.check_set("coovachilli","settings","HS_RADSECRET","testing123"),tr("chilli_var_rradiussecret#Radius Secret"),"string")
  form:Add_help(tr("chilli_var_rradiussecret#Radius Secret"),tr("chilli_help_radiussecret#Radius shared secret for both servers."))
  return form
end

function nasid_form(form,user_level)
  local form = form
  local user_level = user_level or userlevel

  if form == nil then
    form = formClass.new(tr("Captive Portal - NAS Identification"))
  else
    form:Add("subtitle",tr("NAS Identification"))
  end
--  form:Add("subtitle",tr("NAS Identification"))
	form:Add("text","coovachilli.settings.HS_NASID",uci.check_set("coovachilli","settings","HS_NASID","X-Wrt NAS"),tr("cportal_var_radiusnasid#NAS ID"),"string")
  form:Add("text","coovachilli.settings.HS_LOC_NAME",uci.get("coovachilli","settings","HS_LOC_NAME"),tr("cportal_var_radiusnasip#Location Name"),"string")
  form:Add_help(tr("chilli_var_radiuslocationname#Location Name"),tr("chilli_help_radiuslocationname#WISPr Location Name. Should be in the format: &lt;HOTSPOT_OPERATOR_NAME&gt;, &lt;LOCATION&gt;"))
	if user_level > 1 then
		form:Add("text","coovachilli.settings.HS_LOC_NETWORK",uci.check_set("coovachilli","settings","HS_LOC_NETWORK","X-Wrt Network"),tr("cportal_var_radiusnasporttype#Network name"),"string")
		form:Add("text","coovachilli.settings.HS_LOC_ISOCC",uci.get("coovachilli","settings","HS_LOC_ISOCC",""),tr("cportal_var_isocc#ISO Country code"),"string")
		form:Add("text","coovachilli.settings.HS_LOC_CC",uci.get("coovachilli","settings","HS_LOC_CC",""),tr("cportal_var_radiuslocationname#Phone country code"),"string")
		form:Add("text","coovachilli.settings.HS_LOC_AC",uci.get("coovachilli","settings","HS_LOC_AC",""),tr("cportal_var_radiuslocationid#Phone area code"),"string")
	end
  uci.save("coovachilli")
  return form
end

function uam_form(form,user_level,local_portal)
	local user_level = user_level or userlevel
	local local_portal = local_portal or portal
	local form = form
	local homeset = tonumber(uci.get("coovachilli","webadmin","homepage"))
	local loginset = tonumber(uci.get("coovachilli", "webadmin", "loginpage"))
	
	if user_level > 1 or loginset == 0 or homeset > 0 then
		if form ~= nil then form:Add("subtitle","Captive Portal - Universal Authentication Method")
		else form = form or formClass.new("Captive Portal - Universal Authentication Method") end
--		local user_level = user_level or userlevel
		local localuam = localuam or portal
--  	if user_level > 1 and local_portal < 2 then
--  	if user_level > 1 then
--    	form:Add("text","coovachilli.settings.HS_UAMSERVER",uci.check_set("coovachilli","settings","HS_UAMSERVER","192.168.182.1"),tr("cportal_var_uamserver#URL of Web Server"),"string","width:90%")
--    	form:Add_help(tr("cportal_var_uamserver#URL of Web Server"),tr("cportal_help_uamserver#URL of a Webserver handling the authentication."))
--    	form:Add("text","coovachilli.settings.HS_UAMFORMAT",uci.get("coovachilli","settings","HS_UAMFORMAT","http://\$HS_UAMSERVER/cgi-bin/login/login"),tr("cportal_var_format#Path of Login Page"),"string","width:90%")
		if loginset == 0 then 
    		form:Add("text","coovachilli.settings.HS_UAMFORMAT",uci.get("coovachilli","settings","HS_UAMFORMAT"),tr("cportal_var_format#Login Page"),"string","width:90%")
    		form:Add_help(tr("cportal_var_format#URL of Web Server"),tr("cportal_help_format#URL of a Webserver handling the authentication. To use the internal login page put <br>http://url_of_web_server/cgi-bin/login/login"))
	    	form:Add("text","coovachilli.settings.HS_UAMSECRET",uci.get("coovachilli","settings","HS_UAMSECRET"),tr("cportal_var_uamsecret#UAM Secret"),"string")
			form:Add_help(tr("cportal_var_uamsecret#Web Secret"),tr("cportal_help_uamsecret#Shared secret between HotSpot and Webserver (UAM Server)."))
    	end
--  	end
  	if user_level > 2 or homeset > 0 then
	--    	form:Add("text","coovachilli.settings.HS_UAMHOMEPAGE",uci.check_set("coovachilli","settings","HS_UAMHOMEPAGE","http://\$HS_UAMLISTEN:\$HS_UAMPORT/www/coova.html"),tr("cportal_var_uamhomepage#UAM Home Page"),"string","width:90%")
			if homeset == 2 then 
    		form:Add("text","coovachilli.settings.HS_UAMHOMEPAGE",uci.get("coovachilli","settings","HS_UAMHOMEPAGE"),tr("cportal_var_uamhomepage#UAM Home Page"),"string","width:90%")
    		form:Add_help(tr("cportal_var_uamhomepage#Homepage"),tr("cportal_help_uamhomepage#URL of Welcome Page. Unauthenticated users will be redirected to this address, otherwise specified, they will be redirected to UAM Server instead. To use the internal login page put <br>http://url_of_web_server/cgi-bin/login/home"))
			end
			if homeset > 0 then    	
--    		form:Add("text","coovachilli.homepage.redirect",uci.get("coovachilli","homepage","redirect"),tr("cportal_var_uamhomepage#Redirection time"),"int,required,>=0")
    		form:Add("select","coovachilli.homepage.redirect",uci.get("coovachilli","homepage","redirect"),tr("cportal_var_uamhomepage#Redirection time"),"int,required,>=0")
				for i=0, 30 do
					form["coovachilli.homepage.redirect"].options:Add(tostring(i),tostring(i))
				end				
    		form:Add_help(tr("cportal_var_homepage_redirection#Redirection time"),tr("cportal_help_homepage_redirection#Seconds of redirection time. 0 = not redirection"))
    	end

  	end
  	uci.save("coovachilli")
  end
  form =  add_allowed_site(form,user_level)
  return form
end

function add_allowed_site(form,user_level)
	local user_level = user_level or userlevel
	local form = form
  if form == nil then
    form = formClass.new("Sites Allowed")
  else
    form:Add("subtitle",tr("Sites Allowed"))
  end
--  form:Add("uci_set_config","coovachilli","sitesallowed",tr("uamallowed_add#Add Allowed"),"string","width:98%;")
  local t = {}
	local style = ""
	t.label = "Add Allowed 1"
	t.name = "add_sites_allowed"
	t.style = "width:98%;"
	t.script = ""
	t.btlabel = "bt_add_allowed#Add Allowed"
  if t.style ~= "" then style = "style=\""..t.style.."\" " end
  funcname = "funcionalgo"
	form:Add("checkbox","coovachilli.system.paypal",uci.get("coovachilli","system","paypal"),tr("uamallow_paypal#Paypal Allowed"))
	local str = ""
  str = str .. "<table cellspacing=\"2\" border=\"0\" style=\"width:100%;\" ><tr><td width=\"80%\">"
--  str = str .. "<input type=\"hidden\" name=\"FUNCTION\" value=\""..funcname.."\">"
  str = str .. "<input type=\"text\" name=\"allowed_site\""..style..t.script.." />"
  str = str .. "</td><td width=\"10%\" align=\"right\">"
	str = str .. "<input type=\"submit\" name=\""..t.name.."\" value=\""..tr(t.btlabel).."\""..t.script.." />"
  str = str .. "</td></tr></table>"
  form:Add("text_line","varname",str,"Aca Va el Label","string")
  form:Add_help(tr("chilli_var_uamallowed#Sites Allowed"),tr("chilli_help_uamallowed#Comma-seperated list of domain names, urls or network subnets the client can access without authentication (walled gardened)."))
  local sitesallowed = uci.get_type("coovachilli","sitesallowed")
  if sitesallowed then 
    form:Add("subtitle","&nbsp;")
    local strallowed = [[<table width="100%">]]

    for i=1, #sitesallowed do
      strallowed = strallowed..[[<tr><td width="80%">]]
      strallowed = strallowed .. sitesallowed[i].site
      strallowed = strallowed .. [[</td><td width="20%" ><a href="]]
      local sstep = ""
      local soption = ""
      local smenu = ""
      if __FORM.option~=nil then soption = "&option="..__FORM.option end
      if __FORM.step~=nil then sstep = "&step="..__FORM.step end
			if __FORM.__menu ~= nil then smenu = "&__menu="..__FORM.__menu end
      strallowed = strallowed ..__SERVER.SCRIPT_NAME.."?".."DeleteAllowed="..sitesallowed[i][".name"]..smenu..soption..sstep
      strallowed = strallowed ..[[">]]..tr("remove_lnk#remove it")..[[</a></td></tr>]]
    end
    strallowed = strallowed..[[</table>]]
    form:Add("text_line","sitesallowed",strallowed)
  end
  return form
end

function connect_form(form,user_level,localuam)
  if __FORM["authorize"] ~= nil then
    os.execute("chilli_query authorize sessionid "..__FORM["authorize"])
  end
  if __FORM["release"] ~= nil then
    os.execute("chilli_query dhcp-release "..__FORM["release"])
  end
  local authenticated = {["0"] = "No",["1"] = "Yes"}
  local form = tbformClass.new("Captive Portal - Connection List")
  form = tbformClass.new("Local Users")
  form:Add_col("label", "Username","Username", "width:150px;font-size:11px;","","width:150px;font-size:11px;")
  form:Add_col("label", "MAC-Address", "MAC Address", "width:160px;font-size:11px;","string","width:160px;font-size:11px;")
  form:Add_col("label", "IP-Address", "IP Address", "width:140px;font-size:11px;","string","width:140px;font-size:11px;")
  form:Add_col("label", "Status", "Status", "width:60px;font-size:11px;","string","width:60px;font-size:11px;")
  form:Add_col("label", "Session-ID", "Session ID", "width:170px;font-size:11px;","int","width:170px;font-size:11px;")
  form:Add_col("label", "Auth", "Aut", "width:40px;font-size:11px;","int","width:40px;font-size:11px;")
  form:Add_col("label", "SessTime", "Session Time", "width:90px;font-size:11px;","int","width:90px;font-size:11px;")
  form:Add_col("label", "IdleTime", "Idle Time", "width:100px;font-size:11px;","int","width:100px;font-size:11px;")
  form:Add_col("label", "action", " ", "width:200px;font-size:11px;","int","width:200px;font-size:11px;")
  connected = io.popen("chilli_query list")
  for line in connected:lines() do
    local tline = string.split(line," ")
    mac = tline[1]
    ip = tline[2]
    status = tline[3]
    sessId = tline[4]
    authen = authenticated[tline[5]]
    user = tline[6]         
    sessTime = tline[7]         
    idleTime = tline[8]
    startPage = tline[9]
    if tonumber(tline[5]) == 1 then
      action = [[<a href="?release=]]..tline[1].."&__menu="..__FORM["__menu"].."&option="..__FORM["option"]..[[">logout</a>]]
    else
      action = "<a href=\"?release="..tline[1].."&__menu="..__FORM["__menu"].."&option="..__FORM["option"].."\">release</a> - <a href=\"?authorize="..tline[4].."&__menu="..__FORM["__menu"].."&option="..__FORM["option"].."\">authorize</a>"
    end
  
    form:New_row()

    form:set_col("Username",sessId..".Username",user)
    form:set_col("MAC-Address",sessId..".MAC-Address",mac)
    form:set_col("IP-Address",sessId..".IP-Address",ip)
    form:set_col("Status",sessId..".Status",status)
    form:set_col("Session-ID",sessId..".Session-ID",sessId)
    form:set_col("Auth",sessId..".Auth",authen)
    form:set_col("SessTime",sessId..".SessTime",sessTime)
    form:set_col("IdleTime",sessId..".IdleTime",idleTime)
    form:set_col("action",sessId..".action",action)
  end
  return form
end

function pages_form(form,user_level,localuam)
	local user_level = user_level or userlevel
	local pages = reorderpages()
	if pages then
	  form = tbformClass.new("HotSpot Pages")
  	form:Add_col("text","menuorder", "Order", "20px","int>0","width:20px")
  	form:Add_col("text","pagemenu", "Menu Option", "220px","string","width:220px")
  	form:Add_col("text", "pagetitle", "Page Title","220px","string","width:220px")
  	form:Add_col("label", "pagetype", "Type", "100px","string","width:100px")
--  	form.col[form.col.type].options:Add("html","HTML")
--  	form.col[form.col.type].options:Add("fields","Fields List")
--  	form:Add_col("link", "Remove","Remove", "100px","","width:100px",[[onclick="return confirm(]]..tr("This page will be deleted")..[[);"]])
  	form:Add_col("link", "Remove","Remove", "100px","","width:100px",[[onclick="return confirm('This page will be deleted');"]])
		for i=1, #pages do
			local menuorder = pages[i].menuorder or "0"
			local pagemenu  = pages[i].pagemenu 
			local pagetitle = pages[i].pagetitle or ""
			local pagetype  = pages[i].pagetype or ""
			local name = pages[i][".name"]
    	form:New_row()
    	form:set_col("menuorder","chillipages."..name..".menuorder", menuorder)
    	form:set_col("pagemenu","chillipages."..name..".pagemenu", pagemenu)
    	form:set_col("pagetitle","chillipages."..name..".pagetitle", pagetitle)
    	form:set_col("pagetype","chillipages."..name..".pagetype", pagetype)
--    	form:set_col("Show", "Show_"..name, "/cgi-bin/login/home.lua?option="..name)
--    	form:set_col("Edit", "Edit_"..name, "&nbsp;&nbsp;")
    	form:set_col("Remove", "Remove_"..name, __SERVER.SCRIPT_NAME.."?pageremove="..name.."&__menu="..__FORM.__menu.."&option="..__FORM.option)
  	end
	  return form
  end
  return nil
end

function add_page_form(form,user_level)
  if form == nil then
    form = formClass.new("Add new page",true)
  else
    form:Add("subtitle","Add new page")
  end
  form:Add("text_line","add_plugin",[[
	<table>
  <tr>
		<td width="220px">Menu Order</td>
		<td width="220px">Menu name</td>
		<td width="220px">Page's Title</td>
		<td width="220px">Page's Type</td>
	</tr>
  <tr>
		<td><input type="text" name="menuorder" /></td>
		<td><input type="text" name="pagemenu" /></td>
  	<td><input type="text" name="pagetitle" /></td>
  	<td>
			<select name="pagetype" />
				<option value="fields">Fields List</option>
				<option value="html">HTML include</option>
				<option value="file">External file</option>
			</select>
		</td>
	</tr>
  </table>]])
  return form
end

function edit_page_form(user_level,inpage)
	local mypage = uci.get_section("chillipages",inpage)
	local forms = {}
	if mypage.pagetype == "file" then
		forms = edit_fields_page(inpage,mypage)
	elseif mypage.pagetype == "html" then
		forms = edit_fields_page(inpage,mypage)
  else
		forms = edit_fields_page(inpage,mypage)
  end
	return forms
end

function edit_file_page(inpage,mypage)
--	local mypage = uci.get_section("chillipages",inpage)
	form = formClass.new(tr("Customized Page"))
  form:Add("text","chillipages."..inpage.."filename",uci.get("chillipages",inpage,"filename"),tr("File name"))
	return form
end

function edit_html_page(inpage,mypage)
--	local mypage = uci.get_section("chillipages",inpage)
	local mycode = loadfile("/www/cgi-bin/login/"..mypage.htmlcode)
	mycode = "adasdasdasdasd asd ad"
  local form = formClass.new(mypage.pagetitle,true)
  form:Add("text","chillipages."..inpage.."htmlcode",uci.get("chillipages",inpage,"htmlcode"),tr("HTML code"),"string")
  form:Add("text_area" ,"coovachilli_file."..inpage.."htmlcode",mycode,tr("HTML code"),"string","float:right;width:90%;height:300px;")
--   form:Add("text_area","chillipages."..inpage.."htmlcode",uci.get("chillipages",inpage,"htmlcode"),tr("HTML code"),"string","float:right;width:90%;height:300px;")
	return form
end

function edit_fields_page(inpage,mypage)
  local forms = {}
	local deffile = ""
	local findfile = ""
	if mypage.pagetype == "html" then
		deffile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/html_example"
		findfile = mypage.filename
	elseif mypage.pagetype == "fields" then
		deffile = "/usr/lib/lua/lua-xwrt/pkgs/coovachilli/field_example"
		findfile = mypage.filename
	else
		deffile = "/www/file_example.html"
		findfile = "/www"..mypage.filename
	end	

	if __FORM.filecontent then
	  local write_file = io.open(findfile,"w")
  	write_file:write(__FORM.filecontent)
  	write_file:close()
	end

  local form = formClass.new(mypage.pagetitle)
	form:add("disabled_text","chillipages."..inpage..".pagetype",uci.get("chillipages",inpage,"pagetype"),"Page type","","")
	form:add("disabled_text","chillipages."..inpage..".menuorder",uci.get("chillipages",inpage,"menuorder"),"Menu order","","")
	form:add("text_box","chillipages."..inpage..".pagemenu",uci.get("chillipages",inpage,"pagemenu"),"Menu name","string","width:99%;")
	if mypage.pagetype ~= "file" then
		form:add("text_box","chillipages."..inpage..".pagetitle",uci.get("chillipages",inpage,"pagetitle"),"Title of page","string","width:99%;")
	end
	form:add("disabled_text","chillipages."..inpage..".filename",uci.get("chillipages",inpage,"filename"),"File name","","width:99%;")
  forms[1] = form
	if io.exists(findfile) == false then
  	os.execute("cp "..deffile.." "..findfile)
	end
	if __FORM.filecontent1 then
		filecontent = __FORM.filecontent1
	  local write_file = io.open(findfile,"w")
  	write_file:write(__FORM.filecontent1)
  	write_file:close()
	else
  		filecontent = load_file(findfile)
  end

  form = formClass.new(tr("File Content"),true)
  form:Add("text_line","filecontent",[[<TEXTAREA name="filecontent1" rows="15" wrap="off" style="width:100%">]]..filecontent..[[</TEXTAREA>]])
  forms[2] = form
	return forms
end

function login_form(form,user_level,local_portal)
	local user_level = user_level or userlevel
	local local_portal = local_portal or portal
	local form = form
	local homeset = tonumber(uci.get("coovachilli","webadmin","homepage"))
	local loginset = tonumber(uci.get("coovachilli", "webadmin", "loginpage"))
	local form = form
 if form == nil then
    form = formClass.new(tr("Customize Login Page"))
  else
    form:Add("subtitle",tr("Customize Login Page"))
  end
	local str = ""
  str = str .. "<table cellspacing=\"2\" border=\"0\" style=\"width:100%;\" >"
	str = str .. "<tr><th>&nbsp;</th><th>Label</th><th>Value</th><th>Enable</th></tr>"

  str = str .. "<tr><td><strong>Login Message</strong></td><td>"
	str = str ..strform.text_box({name="chillipages.login.msg_label",validate="string",label="loging Msg",value=uci.check_set("chillipages","login","msg_label","Login : ")})
	str = str .."</td><td>"
	str = str .."&nbsp;"
	str = str .."</td><td>"
	str = str ..strform.checkbox({name="chillipages.login.msg_enable",validate="string",label="loging Msg",style="",script="",value=uci.get("chillipages","login","msg_enable"),checked="1"})
	str = str .."</td></tr>"

  str = str .. "<tr><td><strong>Username</strong></td><td>"
	str = str ..strform.text_box({name="chillipages.login.user_label",validate="string",label="loging Username",value=uci.check_set("chillipages","login","user_label","Username ")})
	str = str .."</td><td>"
	str = str .."&nbsp;"
	str = str .."</td><td>"
	str = str .."&nbsp;"
	str = str .."</td></tr>"

  str = str .. "<tr><td><strong>Password</strong></td><td>"
	str = str ..strform.text_box({name="chillipages.login.pass_label",validate="string",label="loging Password",value=uci.check_set("chillipages","login","pass_label","Password ")})
	str = str .."</td><td>"
	str = str ..strform.text_box({name="chillipages.login.pass_value",validate="string",label="loging Password",value=uci.check_set("chillipages","login","pass_value","")})
	str = str .."</td><td>"
	str = str ..strform.checkbox({name="chillipages.login.pass_enable",validate="string",label="loging Password",style="",script="",value=uci.get("chillipages","login","pass_enable"),checked="1"})
	str = str .."</td></tr>"
  str = str .. "</table>"
  form:Add("text_line","varname",str,"Aca Va el Label","string")
  form:Add_help(tr("chilli_var_uamallowed#Sites Allowed"),tr("chilli_help_uamallowed#Comma-seperated list of domain names, urls or network subnets the client can access without authentication (walled gardened)."))
  return form
end


return cportal